LongRange(a,b) returning vector of long a..b (included)
Status: Closed Start date: 14 Feb 2013

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: New Function Estimated time: 2.00 hours

Target version: CoCoALib-0.99532 Spent time: 2.10 hours

Description

I do miss in C++ the convenient cocoa syntax a..b.

In fact it is particularly useful for calling submat.

So I suggest having LongRange in utils.H

(that implies including in it vector.H)

Related issues:

Related to CoCoALib - Feature #357: Constructor for vectors?  CoCoAVector Rejected 24 May 2013

Related to CoCoALib - Feature #1472: Idea for for loops In Progress 23 Jul 2020

Related to CoCoALib - Feature #202: MatrixView/function for viewing a single ... Closed 04 Jul 2012

Related to CoCoALib - Design #64: submat takes only vector<long> Closed 15 Dec 2011

Related to CoCoALib - Design #601: LongRange: in which file should it be decl... In Progress 31 Jul 2014

Related to CoCoALib - Feature #1788: New MatrixView/function "FirstRows/First... Closed 08 Mar 2024

History

#1 - 14 Feb 2013 16:04 - John Abbott

It is a shame to have to include the standard header <vector> in the file utils.H.

It may not be relevant, but I notice that there is a file ULong2Long.H which contains essentially one inline fn.  So we could put LongRange into a

separate file.

However, I believe ULong2Long is in a separate file for a specific good reason: so that the test compilations made by the configure-time script

cpp-flags-ulong2long.sh are particularly simple.

#2 - 15 Feb 2013 18:54 - John Abbott

It's not very important, but JAA thinks that LongRange should not be inline:

its impl is not that short, and run-time efficiency is not that crucial (e.g. it won't be called millions of times).

Unfortunately, making it not inline does not let us remove #include <vector> from the header file... sigh!  Maybe some future version of C++ will allow

it...?

#3 - 24 May 2013 18:58 - Anna Maria Bigatti

- Category set to New Function

- Status changed from New to Feedback

- Assignee set to Anna Maria Bigatti

- Target version set to CoCoALib-0.9953

- % Done changed from 0 to 90
#4 - 03 Jun 2013 17:38 - John Abbott

It might be worth moving the impl into its own separate file: this would remove the need to include vector in the header file for utils.

#5 - 29 Oct 2013 13:50 - Anna Maria Bigatti

John Abbott wrote:

It might be worth moving the impl into its own separate file: this would remove the need to include vector in the header file for utils.

 

I think we'd better keep it in utils: if we find that we have a suitable number of "utils" needing vector we will make a separate file for them and move

there LongRange

#6 - 21 Mar 2014 14:29 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.9953 to CoCoALib-0.99532

#7 - 01 Apr 2014 19:15 - Anna Maria Bigatti

- Estimated time set to 2.00 h

#8 - 02 Apr 2014 07:33 - Anna Maria Bigatti

I added some commented out calls to LongRange (to replace the existing for loops).

For paranoia, needs testing (not my code, mainly ApproxPts2)

#9 - 03 Apr 2014 11:38 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

No problems in almost a year --> closing.

#10 - 23 Jul 2020 20:40 - John Abbott

- Related to Feature #1472: Idea for for loops added

#11 - 08 Mar 2024 09:05 - Anna Maria Bigatti

- Related to Feature #202: MatrixView/function for viewing a single row or column (RowMat, ColMat) added

#12 - 08 Mar 2024 09:16 - Anna Maria Bigatti

- Related to Design #64: submat takes only vector<long> added

#13 - 08 Mar 2024 09:16 - Anna Maria Bigatti

- Related to Design #601: LongRange: in which file should it be declared/defined? added

#14 - 08 Mar 2024 10:12 - Anna Maria Bigatti

- Related to Feature #1788: New MatrixView/function "FirstRows/FirstCols"? added
